const prefStringClick2TabReopenInBackground = "click2tab.tab.reopenInBackground";
const prefStringClick2TabIndexInTabList = "click2tab.tab.indexInTabList";
const prefStringClick2TabRightClickTabToRemove = "click2tab.tab.rightClickTabToRemove";
const prefStringClick2TabSaveClosedTabs = "click2tab.tab.saveClosedTabs";
const prefStringClick2TabSaveOpenTabs = "click2tab.tab.saveOpenTabs";
const prefStringClick2TabClosedCacheSize = "click2tab.tab.closedCacheSize";
const prefStringClick2TabClosedListLength = "click2tab.tab.closedListLength";
const prefStringClick2TabShowMoreSubmenu = "click2tab.tab.showMoreSubmenu";

const prefStringClick2TabClearHistory = "click2tab.tab.clearHistory";
const prefStringClick2TabCtlWCloseTab = "click2tab.tab.ctlWCloseTab";

const prefStringClick2TabBookmark = "click2tab.tab.bookmark";
const prefStringClick2TabHistory = "click2tab.tab.history";
const prefStringClick2TabUseMiddleClick = "click2tab.tab.useMiddleClick";

const prefStringClick2TabCloseTabButtonContext = "click2tab.tab.closeTabButtonContext";
const prefStringClick2TabCloseTabButtonMiddleClick = "click2tab.tab.closeTabButtonMiddleClick";
const prefStringClick2TabReopenTabContext = "click2tab.tab.reopenTabContext";
const prefStringClick2TabReopenTabsTabContext = "click2tab.tab.reopenTabsTabContext";
const prefStringClick2TabReplaceGoMenuItem = "click2tab.tab.replaceGoMenuItem";
const prefStringClick2TabShortcutKeyUndo = "click2tab.tab.shortcutKeyUndo";

const NC_NS_Click2Tab = "http://home.netscape.com/NC-rdf#";

function isBookmarkletClick2Tab(aSelection, aDS)
{
    if (aSelection && (aSelection.length == 1)
        && ((aSelection.type[0] == "Bookmark") || (aSelection.type[0] == "ImmutableBookmark")))
    {
        var jsURL = /^ *javascript:/;
        return jsURL.test(BookmarksUtils.getProperty(aSelection.item[0], NC_NS_Click2Tab+"URL", aDS));
    }
    else
        return false;
}

function openInWebPanelClick2Tab(aSelection, aDS)
{
    if (aSelection && (aSelection.length == 1)
        && ((aSelection.type[0] == "Bookmark") || (aSelection.type[0] == "ImmutableBookmark")))
        return BMDS.GetTarget(aSelection.item[0], RDF.GetResource(NC_NS_Click2Tab + "WebPanel"), true);
    else
        return false;
}

// Based on the preference settings, change the browserTarget accordingly to open item in new tab
// when current tab isn't blank
function whereToOpenLinkClick2Tab(aEvent, prefString, aSelection, aDS)
{
    var browserTarget = whereToOpenLink(aEvent);

    var prefService = Components.classes['@mozilla.org/preferences-service;1']
                                .getService(Components.interfaces.nsIPrefService).getBranch(null);
    if (prefService.getBoolPref(prefString)
        && !isBookmarkletClick2Tab(aSelection, aDS)
        && !openInWebPanelClick2Tab(aSelection, aDS))
        if (prefService.getBoolPref(prefStringClick2TabUseMiddleClick) && (aEvent.button == 1))
            browserTarget = "current";
        else
        {
            var w = getTopWin();
            var gBrowser = w.document.getElementById("content");
            if ((browserTarget == "current")
                && (gBrowser.mCurrentBrowser.webProgress.isLoadingDocument
                    || (gBrowser.mCurrentBrowser.currentURI.spec != "about:blank")))
                browserTarget = "tab";
        }

    return browserTarget;
}